#include <sta/system_event.hpp>

#ifdef STA_SYSTEM_EVENT_ENABLE

#include <cmsis_os2.h>


extern osEventFlagsId_t systemEventHandle;


namespace sta
{
	void signalSystemEvents(uint32_t flags)
	{
		osEventFlagsSet(systemEventHandle, flags);
	}
	
	
	void waitForSystemEvents(uint32_t flags, uint32_t options, uint32_t timeout)
	{
		osEventFlagsWait(systemEventHandle, flags, options | osFlagsNoClear, timeout);
	}
	
	
	void signalStartupEvent()
	{
		signalSystemEvents(STA_SYSTEM_EVENT_STARTUP);
	}

	void waitForStartupEvent()
	{
		waitForSystemEvents(STA_SYSTEM_EVENT_STARTUP, osFlagsWaitAll, osWaitForever);
	}
} // namespace sta


#endif // STA_SYSTEM_EVENT_ENABLE